/**
 *******************************************************************************
 *
 * @file atm_adv_param_internal.h
 *
 * @brief Atmosic BLE advertising default parameter
 *
 * Copyright (C) Atmosic 2020-2022
 *
 *******************************************************************************
 */

// Please use GAP_ADV_PARM_NAME to overwrite the parameter setting by example
// Prevent to modify this framework global default parameter setting

#pragma once
#include "atm_adv_param.h"

#ifdef __cplusplus
extern "C" {
#endif

// Default Create Parameter Setting
#define DEFAULT_CREATE_PARAM_CONST 1
#define DEFAULT_OWNER_ADDR_TYPE BLE_OWN_STATIC_ADDR
#define DEFAULT_CREATE_TYPE ADV_TYPE_LEGACY
#define DEFAULT_CREATE_PROPERTY ADV_LEGACY_UNDIR_CONN_MASK
#define DEFAULT_CREATE_FILTER_POLICY FILTER_SCAN_ANY_CON_ANY
#define DEFAULT_CREATE_CHNL_MAP ADV_ALL_CHNLS
#define DEFAULT_CREATE_PRIM_PHY BLE_GAP_PHY_1MBPS
#define DEFAULT_CREATE_DISCOVERY_MODE ADV_MODE_GEN_DISC
#define DEFAULT_CREATE_INTERVAL_MIN (ADV_INTERVAL_MIN * 2)
#define DEFAULT_CREATE_INTERVAL_MAX (ADV_INTERVAL_MIN * 2)
#define DEFAULT_CREATE_MAX_TX_POWER 0
#define DEFAULT_CREATE_SEC_MAX_SKIP 0
#define DEFAULT_CREATE_SEC_PHY BLE_GAP_PHY_1MBPS
#define DEFAULT_CREATE_SEC_ADV_SID 0
#define DEFAULT_CREATE_PERI_INTERVAL_MIN 80
#define DEFAULT_CREATE_PERI_INTERVAL_MAX 80
#define DEFAULT_CREATE_PEER_ADDR_TYPE 0
#define DEFAULT_CREATE_PEER_ADDR 0

// Default Start Parameter Setting
#define DEFAULT_START_PARAM_CONST 1
#define DEFAULT_START_DURATION 0
#ifdef AUTO_TEST
#ifdef IS_FOR_SIM
    #define DEFAULT_START_MAX_ADV_EVENT 8
#else // IS_FOR_SIM
    #define DEFAULT_START_MAX_ADV_EVENT 80
#endif // IS_FOR_SIM
#else // AUTO_TEST
    #define DEFAULT_START_MAX_ADV_EVENT 0
#endif // AUTO_TEST

// Default Data Parameter Setting
#define DEFAULT_DATA_PARAM_CONST 1
#define DEFAULT_DATA_ADV_ENABLE 1
#define DEFAULT_DATA_SCANRSP_ENABLE 1
#define DEFAULT_DATA_ADV_PAYLOAD \
    0x0c,0x09,'A','t','m','o','s','i','c','-','A','D','V'
#define DEFAULT_DATA_SCANRSP_PAYLOAD \
    0x09,0xff,0x00,0x60,'R','W','-','B','L','E'

/************************************/
//           parameters             //
/************************************/
/// --- ADVs Create Parameter Constant-------
/// To change at runtime, need to set 0
#ifndef CFG_ADV_CREATE_PARAM_CONST
#define CFG_ADV_CREATE_PARAM_CONST DEFAULT_CREATE_PARAM_CONST
#endif

/// -------- ADV0 Register Parameter------------
#ifndef CFG_ADV0_OWNER_ADDR_TYPE
#define CFG_ADV0_OWNER_ADDR_TYPE DEFAULT_OWNER_ADDR_TYPE
#endif
#ifndef CFG_ADV0_CREATE_TYPE
#define CFG_ADV0_CREATE_TYPE DEFAULT_CREATE_TYPE
#endif
#ifndef CFG_ADV0_CREATE_PROPERTY
#define CFG_ADV0_CREATE_PROPERTY DEFAULT_CREATE_PROPERTY
#endif
#ifndef CFG_ADV0_CREATE_FILTER_POLICY
#define CFG_ADV0_CREATE_FILTER_POLICY DEFAULT_CREATE_FILTER_POLICY
#endif
#ifndef CFG_ADV0_CREATE_PEER_ADDR_TYPE
#define CFG_ADV0_CREATE_PEER_ADDR_TYPE DEFAULT_CREATE_PEER_ADDR_TYPE
#endif
#ifndef CFG_ADV0_CREATE_PEER_ADDR
#define CFG_ADV0_CREATE_PEER_ADDR DEFAULT_CREATE_PEER_ADDR
#endif
#ifndef CFG_ADV0_CREATE_CHNL_MAP
#define CFG_ADV0_CREATE_CHNL_MAP DEFAULT_CREATE_CHNL_MAP
#endif
#ifndef CFG_ADV0_CREATE_PRIM_PHY
#define CFG_ADV0_CREATE_PRIM_PHY DEFAULT_CREATE_PRIM_PHY
#endif
#ifndef CFG_ADV0_CREATE_DISCOVERY_MODE
#define CFG_ADV0_CREATE_DISCOVERY_MODE DEFAULT_CREATE_DISCOVERY_MODE
#endif
#ifndef CFG_ADV0_CREATE_INTERVAL_MIN
#define CFG_ADV0_CREATE_INTERVAL_MIN DEFAULT_CREATE_INTERVAL_MIN
#endif
#ifndef CFG_ADV0_CREATE_INTERVAL_MAX
#define CFG_ADV0_CREATE_INTERVAL_MAX DEFAULT_CREATE_INTERVAL_MAX
#endif
#ifndef CFG_ADV0_CREATE_MAX_TX_POWER
#define CFG_ADV0_CREATE_MAX_TX_POWER DEFAULT_CREATE_MAX_TX_POWER
#endif
#ifndef CFG_ADV0_CREATE_SEC_MAX_SKIP
#define CFG_ADV0_CREATE_SEC_MAX_SKIP DEFAULT_CREATE_SEC_MAX_SKIP
#endif
#ifndef CFG_ADV0_CREATE_SEC_PHY
#define CFG_ADV0_CREATE_SEC_PHY DEFAULT_CREATE_SEC_PHY
#endif
#ifndef CFG_ADV0_CREATE_SEC_ADV_SID
#define CFG_ADV0_CREATE_SEC_ADV_SID DEFAULT_CREATE_SEC_ADV_SID
#endif
#ifndef CFG_ADV0_CREATE_PERI_INTERVAL_MIN
#define CFG_ADV0_CREATE_PERI_INTERVAL_MIN DEFAULT_CREATE_PERI_INTERVAL_MIN
#endif
#ifndef CFG_ADV0_CREATE_PERI_INTERVAL_MAX
#define CFG_ADV0_CREATE_PERI_INTERVAL_MAX DEFAULT_CREATE_PERI_INTERVAL_MAX
#endif

/// -------- ADV1 Register Parameter------------
#ifndef CFG_ADV1_OWNER_ADDR_TYPE
#define CFG_ADV1_OWNER_ADDR_TYPE DEFAULT_OWNER_ADDR_TYPE
#endif
#ifndef CFG_ADV1_CREATE_TYPE
#define CFG_ADV1_CREATE_TYPE DEFAULT_CREATE_TYPE
#endif
#ifndef CFG_ADV1_CREATE_PROPERTY
#define CFG_ADV1_CREATE_PROPERTY DEFAULT_CREATE_PROPERTY
#endif
#ifndef CFG_ADV1_CREATE_FILTER_POLICY
#define CFG_ADV1_CREATE_FILTER_POLICY DEFAULT_CREATE_FILTER_POLICY
#endif
#ifndef CFG_ADV1_CREATE_PEER_ADDR_TYPE
#define CFG_ADV1_CREATE_PEER_ADDR_TYPE DEFAULT_CREATE_PEER_ADDR_TYPE
#endif
#ifndef CFG_ADV1_CREATE_PEER_ADDR
#define CFG_ADV1_CREATE_PEER_ADDR DEFAULT_CREATE_PEER_ADDR
#endif
#ifndef CFG_ADV1_CREATE_CHNL_MAP
#define CFG_ADV1_CREATE_CHNL_MAP DEFAULT_CREATE_CHNL_MAP
#endif
#ifndef CFG_ADV1_CREATE_PRIM_PHY
#define CFG_ADV1_CREATE_PRIM_PHY DEFAULT_CREATE_PRIM_PHY
#endif
#ifndef CFG_ADV1_CREATE_DISCOVERY_MODE
#define CFG_ADV1_CREATE_DISCOVERY_MODE DEFAULT_CREATE_DISCOVERY_MODE
#endif
#ifndef CFG_ADV1_CREATE_INTERVAL_MIN
#define CFG_ADV1_CREATE_INTERVAL_MIN DEFAULT_CREATE_INTERVAL_MIN
#endif
#ifndef CFG_ADV1_CREATE_INTERVAL_MAX
#define CFG_ADV1_CREATE_INTERVAL_MAX DEFAULT_CREATE_INTERVAL_MAX
#endif
#ifndef CFG_ADV1_CREATE_MAX_TX_POWER
#define CFG_ADV1_CREATE_MAX_TX_POWER DEFAULT_CREATE_MAX_TX_POWER
#endif
#ifndef CFG_ADV1_CREATE_SEC_MAX_SKIP
#define CFG_ADV1_CREATE_SEC_MAX_SKIP DEFAULT_CREATE_SEC_MAX_SKIP
#endif
#ifndef CFG_ADV1_CREATE_SEC_PHY
#define CFG_ADV1_CREATE_SEC_PHY DEFAULT_CREATE_SEC_PHY
#endif
#ifndef CFG_ADV1_CREATE_SEC_ADV_SID
#define CFG_ADV1_CREATE_SEC_ADV_SID DEFAULT_CREATE_SEC_ADV_SID
#endif
#ifndef CFG_ADV1_CREATE_PERI_INTERVAL_MIN
#define CFG_ADV1_CREATE_PERI_INTERVAL_MIN DEFAULT_CREATE_PERI_INTERVAL_MIN
#endif
#ifndef CFG_ADV1_CREATE_PERI_INTERVAL_MAX
#define CFG_ADV1_CREATE_PERI_INTERVAL_MAX DEFAULT_CREATE_PERI_INTERVAL_MAX
#endif


/// ------- ADV Start Parameter Constant----
/// To change at runtime, need to set 0
#ifndef CFG_ADV_START_PARAM_CONST
#define CFG_ADV_START_PARAM_CONST DEFAULT_START_PARAM_CONST
#endif

/// ------- ADV0 Start Parameter----
/// Advertising duration (in unit of 10ms). 0 means that advertising continues
/// until the host disables it
#ifndef CFG_ADV0_START_DURATION
#define CFG_ADV0_START_DURATION DEFAULT_START_DURATION
#endif
/// The maximum number of extended ad events that the controller should try to
/// send before terminating the extended adv.
/// Valid only if extended advertising
#ifndef CFG_ADV0_START_MAX_ADV_EVENT
#define CFG_ADV0_START_MAX_ADV_EVENT DEFAULT_START_MAX_ADV_EVENT
#endif

/// ------- ADV1 Start Parameter----
/// Advertising duration (in unit of 10ms). 0 means that advertising continues
/// until the host disable it
#ifndef CFG_ADV1_START_DURATION
#define CFG_ADV1_START_DURATION DEFAULT_START_DURATION
#endif
/// The maximum number of extended ad events that the controller should try to
/// send before terminating the extended adv.
/// Valid only if extended advertising
#ifndef CFG_ADV1_START_MAX_ADV_EVENT
#define CFG_ADV1_START_MAX_ADV_EVENT DEFAULT_START_MAX_ADV_EVENT
#endif

/// ------- ADV Data Parameter Constant----
/// To change at runtime, need to set 0
#ifndef CFG_ADV_DATA_PARAM_CONST
#define CFG_ADV_DATA_PARAM_CONST DEFAULT_DATA_PARAM_CONST
#endif

/// ------- ADV0 Set Data Parameter----
#ifndef CFG_ADV0_DATA_ADV_ENABLE
#define CFG_ADV0_DATA_ADV_ENABLE DEFAULT_DATA_ADV_ENABLE
#endif
#ifndef CFG_ADV0_DATA_SCANRSP_ENABLE
#define CFG_ADV0_DATA_SCANRSP_ENABLE DEFAULT_DATA_SCANRSP_ENABLE
#endif
#ifndef CFG_ADV0_DATA_ADV_PAYLOAD
#define CFG_ADV0_DATA_ADV_PAYLOAD DEFAULT_DATA_ADV_PAYLOAD
#endif
#ifndef CFG_ADV0_DATA_SCANRSP_PAYLOAD
#define CFG_ADV0_DATA_SCANRSP_PAYLOAD DEFAULT_DATA_SCANRSP_PAYLOAD
#endif

/// ------- ADV1 Set Data Parameter----
#ifndef CFG_ADV1_DATA_ADV_ENABLE
#define CFG_ADV1_DATA_ADV_ENABLE DEFAULT_DATA_ADV_ENABLE
#endif
#ifndef CFG_ADV1_DATA_SCANRSP_ENABLE
#define CFG_ADV1_DATA_SCANRSP_ENABLE DEFAULT_DATA_SCANRSP_ENABLE
#endif
#ifndef CFG_ADV1_DATA_ADV_PAYLOAD
#define CFG_ADV1_DATA_ADV_PAYLOAD DEFAULT_DATA_ADV_PAYLOAD
#endif
#ifndef CFG_ADV1_DATA_SCANRSP_PAYLOAD
#define CFG_ADV1_DATA_SCANRSP_PAYLOAD DEFAULT_DATA_SCANRSP_PAYLOAD
#endif

#ifdef __cplusplus
}
#endif
